# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetCloudforceOneRequestsResult',
    'AwaitableGetCloudforceOneRequestsResult',
    'get_cloudforce_one_requests',
    'get_cloudforce_one_requests_output',
]

@pulumi.output_type
class GetCloudforceOneRequestsResult:
    """
    A collection of values returned by getCloudforceOneRequests.
    """
    def __init__(__self__, account_identifier=None, id=None, max_items=None, results=None):
        if account_identifier and not isinstance(account_identifier, str):
            raise TypeError("Expected argument 'account_identifier' to be a str")
        pulumi.set(__self__, "account_identifier", account_identifier)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if max_items and not isinstance(max_items, int):
            raise TypeError("Expected argument 'max_items' to be a int")
        pulumi.set(__self__, "max_items", max_items)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter(name="accountIdentifier")
    def account_identifier(self) -> builtins.str:
        """
        Identifier
        """
        return pulumi.get(self, "account_identifier")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="maxItems")
    def max_items(self) -> Optional[builtins.int]:
        """
        Max items to fetch, default: 1000
        """
        return pulumi.get(self, "max_items")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetCloudforceOneRequestsResultResult']:
        """
        The items returned by the data source
        """
        return pulumi.get(self, "results")


class AwaitableGetCloudforceOneRequestsResult(GetCloudforceOneRequestsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCloudforceOneRequestsResult(
            account_identifier=self.account_identifier,
            id=self.id,
            max_items=self.max_items,
            results=self.results)


def get_cloudforce_one_requests(account_identifier: Optional[builtins.str] = None,
                                max_items: Optional[builtins.int] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCloudforceOneRequestsResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_cloudforce_one_requests = cloudflare.get_cloudforce_one_requests(account_identifier="023e105f4ecef8ad9ca31a8372d0c353")
    ```


    :param builtins.str account_identifier: Identifier
    :param builtins.int max_items: Max items to fetch, default: 1000
    """
    __args__ = dict()
    __args__['accountIdentifier'] = account_identifier
    __args__['maxItems'] = max_items
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getCloudforceOneRequests:getCloudforceOneRequests', __args__, opts=opts, typ=GetCloudforceOneRequestsResult).value

    return AwaitableGetCloudforceOneRequestsResult(
        account_identifier=pulumi.get(__ret__, 'account_identifier'),
        id=pulumi.get(__ret__, 'id'),
        max_items=pulumi.get(__ret__, 'max_items'),
        results=pulumi.get(__ret__, 'results'))
def get_cloudforce_one_requests_output(account_identifier: Optional[pulumi.Input[builtins.str]] = None,
                                       max_items: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetCloudforceOneRequestsResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_cloudforce_one_requests = cloudflare.get_cloudforce_one_requests(account_identifier="023e105f4ecef8ad9ca31a8372d0c353")
    ```


    :param builtins.str account_identifier: Identifier
    :param builtins.int max_items: Max items to fetch, default: 1000
    """
    __args__ = dict()
    __args__['accountIdentifier'] = account_identifier
    __args__['maxItems'] = max_items
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getCloudforceOneRequests:getCloudforceOneRequests', __args__, opts=opts, typ=GetCloudforceOneRequestsResult)
    return __ret__.apply(lambda __response__: GetCloudforceOneRequestsResult(
        account_identifier=pulumi.get(__response__, 'account_identifier'),
        id=pulumi.get(__response__, 'id'),
        max_items=pulumi.get(__response__, 'max_items'),
        results=pulumi.get(__response__, 'results')))
